#!/usr/bin/python

# Read table
f=open('MTTableData.txt',mode='r')
linelist=f.readlines()
f.close()
table = []
footnotes = []
usetable = True
for line in linelist:
    if   line.strip()=='Table':     usetable=True
    elif line.strip()=='Footnotes': usetable=False
    elif line.strip()=='':          pass
    else:
        if usetable:
            table.append(line.split('&'))
        else:
            footnotes.append(line.split('&'))

# Clean up table & footnotes lists
for obj in [table, footnotes]:
    for i in range(len(obj)):
        for j in range(len(obj[i])):
            obj[i][j]=obj[i][j].strip()

# Footnoteify the table
for i in range(len(table)):
    if table[i][3] != '': table[i][2]=table[i][2]+'$^{'+table[i][3]+'}$'
    del table[i][3]

# Read Footnotes
for i in range(len(footnotes)):
    footnotes[i][0]='$^'+footnotes[i][0]+'$'

# Ready table header & footer
header = [\
        '%-----------------------------',\
        '% Table of MT -> C Mapping',\
        '%-----------------------------',\
        '\\newlength{\\mtcolheadwidth}',\
        '\\newlength{\\desccolheadwidth}',\
        '\\newlength{\\ccolheadwidth}',\
        '\\settowidth{\\mtcolheadwidth}{MT}',\
        '\\settowidth{\\desccolheadwidth}{Description}',\
        '\\settowidth{\\ccolheadwidth}{C}',\
        '\\newlength{\\mtcolwidth}',\
        '\\newlength{\\desccolwidth}',\
        '\\newlength{\\ccolwidth}',\
        '\\settowidth{\\mtcolwidth}{801-848}',\
        '\\settowidth{\\desccolwidth}{Total charged particle stopping power.}',\
        '\\settowidth{\\ccolwidth}{20,21a}',\
        '\\addtolength{\\mtcolwidth}{-\\mtcolheadwidth}',\
        '\\addtolength{\\desccolwidth}{-\\desccolheadwidth}',\
        '\\addtolength{\\ccolwidth}{-\\ccolheadwidth}',\
        '%\\begin{widetext}',\
        '\\begin{center}',\
        '\\squeezetable',\
        '\\begin{table*}',\
        '\\begin{tabular}{rllcrll}\\cline{1-3}\\cline{5-7}\\vspace*{-0.3cm}\\\\\\cline{1-3}\\cline{5-7}',\
        '\\hspace*{\\mtcolwidth}MT&Description\\hspace*{\\desccolwidth}&C\\hspace*{\\ccolwidth}&\\hspace*{0.5cm}&\\hspace*{\\mtcolwidth}MT&Description\\hspace*{\\desccolwidth}&C\\hspace*{\\ccolwidth}',\
        '\\\\\\cline{1-3}\\cline{5-7}\\vspace*{-0.3cm}'\
    ]
footer0 = ['\\vspace*{-0.3cm}\\\\\\cline{1-3}\\cline{5-7}\\end{tabular}']
footer1 = [\
        '\\caption{ENDF MT numbers and their rough ENDL equivalent.}',\
        '\\label{MTnumbers}',\
        '\\end{table*}',\
        '\\end{center}',\
        '%\\end{widetext}'\
    ]

# Make the table a 2-column deal
smushtable = [[]]
half = len(table)/2
#print len(table),half
for i in range(half):
    smushtable.append(table[i]+['']+table[i+half])
if len(table) != half*2:
    smushtable.append(['','','','']+table[len(table)-1])

# Write out table
f=open('MTTable.tex',mode='w')
for i in header:
    f.write(i+'\n')
for row in smushtable:
    f.write('&'.join(row)+'\\\\\\cline{1-3}\cline{5-7}\n')
for i in footer0:
    f.write(i+'\n')
f.write('\\\\\\vspace*{0.5em}')
fmboxen=[]
for row in footnotes:
    fmboxen.append('\\makebox[0.9\\textwidth][l]{'+' '.join(row)+'}')
    #f.write('\\makebox[0.9\\textwidth][l]{'+' '.join(row)+'}')
f.write('\\\\'.join(fmboxen))
for i in footer1:
    f.write(i+'\n')
f.close()
