# MT         rxn              C
data = '''1       & (n,total)         & 1                               
2       & (z,elastic)       & 10                                 
3       & (z,non-elastic)   & 55                                            
4       & (z,n)             & n/a                                                     
5       & (z,anything)      & n/a                                      
10      & (z,continuum)     & n/a                             
11      & (n,2nd)           & 32    
16      & (z,2n)            & 12    
17      & (z,3n)            & 13    
18      & (z,f)             & 15                  
19      & (n,f) -- $1^{st}$ chance fission.  & n/a    
20      & (n,nf) -- $2^{nd}$ chance fission.  & n/a    
21      & (n,2nf) -- $3^{rd}$ chance fission. & n/a    
22      & (z,na)     & 26    
23      & (z,n3a)    & 36    
24      & (z,2na)    & 33    
25      & (z,3na)    & 16    
27      & (n,abs)           & n/a   
28      & (z,np)            & 20
29      & (z,n2a)    & 27                                                 
30      & (z,2n2a)   & n/a                                          
32      & (z,nd)            & 22                                                 
33      & (z,nt)            & 24                                                 
34      & (z,nH)       & 25                                                
35      & (z,nd2a)   & n/a                                           
36      & (z,nt2a)   & n/a                                        
37      & (z,4n)            & 14    
38      & (n,3nf) -- $4^{th}$ chance fission. & n/a    
41      & (z,2np)           & 29                                               
42      & (z,3np)           & 16                                              
44      & (n,n2p)           & 17    
45      & (n,npa)    & 34    
50      & (z,n[0]) -- excitation of g.s.  & 11                                        
51-90   & (z,n[n]) -- excitation of n$^{th}$ excited state         & 11  
91      & (z,n[c]) -- excitation to continuum       & 11                          
101     & (n,disappearance) & n/a                             
102     & (z,g)      & 46   
103     & (z,p)             & 40                         
104     & (z,d)             & 41                           
105     & (z,t)             & 42                           
106     & (z,H)        & 44                              
107     & (z,a)      & 45                              
108     & (z,2a)     & 37                        
109     & (z,3a)     & n/a                         
111     & (z,2p)            & 18   
112     & (z,pa)     & 48                          
113     & (z,t2a)    & 42                                
114     & (z,d2a)    & n/a                  
115     & (z,pd)            & 19                     
116     & (z,pt)            & 39                     
116     & (z,da)            & 47                     
151     & (n,resonance)     & n/a  
201     & (z,Xn)            & -1                          
202     & (z,Xg)     & -1   
203     & (z,Xp)            & 50                                                                 
204     & (z,Xd)            & 51                       
205     & (z,Xt)            & 52   
206     & (z,XH)       & 53                   
207     & (z,Xa)     & 54   
208-218 & Various meson and antiparticle production $sigma$'s  & n/a 
251-253 & Various elastic neutrons scattering parameters.           & n/a                     
301     & Energy release for total and partial $sigma$'s.   & n/a  
451     & Heading or title information, MF=1 only.                         & n/a   
452     & (z,f) $bar{nu}$ total, i.e. prompt plus delayed, fission.            & 15    
454     & (z,f) Independent fission product yields.                         & 15    
455     & (z,f) $bar{nu}$ for delayed fission.                            & 15                                                       
456     & (z,f) $bar{nu}$ for prompt fission.                             & 15                                                    
457     & (z,f) Radioactive decay data.                                     & n/a   
458     & (z,f) Energy release in fission for incident $n$'s.            & 15     
459     & (z,f) Cumulative fission product yields.                          & 15    
500     & Total charged particle stopping power.    & n/a  
501     & Total photon interaction $sigma$.   & 70   
502     & Photon coherent scattering.               & 71   
504     & Photon incoherent scattering.             & 72   
505     & Imaginary scattering factor.      & n/a  
506     & Real scattering factor.           & n/a  
515     & Pair production, electron field.  & n/a  
516     & Pair production.                  & 74   
517     & Pair production, nuclear field.   & n/a  
522     & Photoelectric absorption.         & 73   
534-572 & Various subshell photoelectric $sigma$'s. & n/a  
600     & (z,p[0])      & 40     
601-648 & (z,p[n])      & 40     
649     & (z,p[c])      & 40     
650     & (z,d[0])      & 41     
651-698 & (z,d[n])      & 41     
699     & (z,d[c])      & 41     
700     & (z,t[0])      & 42     
701-748 & (z,t[n])      & 42     
749     & (z,t[c])      & 42     
750     & (z,H[0]) & 44     
751-798 & (z,H[n]) & 44     
799     & (z,H[c]) & 44     
800     & (z,a[0])& 45    
801-848 & (z,a[n])& 45    
849     & (z,a[c])& 45    
851     & Lumped reaction covariances.& n/a '''

class Entry:
    def __init__(self, line):
        sline = line.split('&')
        self.MT=sline[0]
        self.rxn=sline[1]
        self.C=sline[2]
    def get_C(self):
        try:
            return int(self.C)
        except:
            return -1
    def get_MT(self):
        try:
            return int(self.MT)
        except:
            if self.MT.find('-')!=-1:
                sMT = self.MT.split('-')
                return range(int(sMT[0]),int(sMT[1])+1)
            else: return 0
    def get_yoList(self):
        istart = self.rxn.find('(')
        iend   = self.rxn.find(')')
        if istart == -1: return []
        icomma = self.rxn.find(',')
        products = self.rxn[icomma+1:iend]
        for wierdPrduct in ['total','elastic','anything','disappearance','continuum','abs','resonance']:
            if products.find(wierdPrduct)!=-1: return []
        products = list(products)
        yoList = 8*[0]
        count = 1
        while products:
            letter=products.pop(0)
            if   letter == 'f':
                yoList[0]+=-1
                count = 1
            elif letter == 'n':
                yoList[1]+=count
                count = 1
            elif letter == 'p':
                yoList[2]+=count
                count = 1
            elif letter == 'd':
                yoList[3]+=count
                count = 1
            elif letter == 't':
                yoList[4]+=count
                count = 1
            elif letter == 'H':
                yoList[5]+=count
                count = 1
            elif letter == 'a':
                yoList[6]+=count
                count = 1
            elif letter == 'g':
                yoList[7]+=count
                count = 1
            elif letter.isdigit():
                count = int(letter)
            elif letter == 'X':
                count = -1
            elif letter == '[':
                return yoList
            else: raise "Illegal character: '"+letter+"'"
        return yoList
    def __str__(self):
        return '    '.join(map(str,[self.get_MT(),self.get_C(),self.get_yoList(),self.rxn]))
    def makeCPPInstance(self, mt=None):
        if mt==None:
            if type(self.MT) == list:
                mt = self.MT[0]
            else:
                mt = self.MT
        return 'yoMap[MTCPair( '+str(mt)+', '+str(self.get_C())+' )] = YoList( '+', '.join( map(str,['"'+self.rxn.strip()+'"']+self.get_yoList()) )+" );"
if __name__=="__main__":
    MTEntryMap = {}
    for line in data.split('\n'):
        e = Entry(line)
        if type(e.get_MT()) == list:
            for mt in e.get_MT():
                MTEntryMap[mt]=e
        else:
            MTEntryMap[e.get_MT()]=e
    print "void ENDLClass::fill_yoMap()\n{"
    for mt in MTEntryMap.keys():
        print "  "+MTEntryMap[mt].makeCPPInstance(mt)
    print '}'
