/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1841 $
 * $Date: 2006-04-14 16:27:07 -0700 (Fri, 14 Apr 2006) $
 * $Id: endl_precision.cpp 1841 2006-04-14 23:27:07Z hedstrom $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

#include "endl_precision.hpp"

// ---------------------- ENDL_EPSILON ---------------
double ENDL_EPSILON( double E )
{
  double epsilon = pow(10.0,ceil(log10( E ))-ENDL_DATA_PRECISION);
  double SMALLEST_DE = Global.Value("smallest_dE");
  if( epsilon < SMALLEST_DE ){
    return SMALLEST_DE;
  }
  else{
    return epsilon;
  }
}
