/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1867 $
 * $Date: 2006-05-15 10:19:04 -0700 (Mon, 15 May 2006) $
 * $Author: dbrown $
 * $Id: endl_precision.hpp 1867 2006-05-15 17:19:04Z dbrown $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

#ifndef __ENDL_PRECISION_H
#define __ENDL_PRECISION_H

#include "global_params.hpp"

extern GlobalParameterClass Global;

//! The smallest energy difference, but make it positive
double ENDL_EPSILON( double E );

//! The width of a jump
inline double ENDL_JUMP_WIDTH( double E )
{ return Global.Value("jump_factor")*ENDL_EPSILON( E ); }
//{ return 2.0*ENDL_EPSILON( E ); }

//! Make a delta function wider than a jump.
inline double DELTA_WIDTH( double E )
{ return 1.1*Global.Value("jump_factor")*ENDL_EPSILON( E ); }
//{ return 2.2*ENDL_EPSILON( E ); }

#endif
