/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1735 $
 * $Date: 2006-02-09 13:47:26 -0800 (Thu, 09 Feb 2006) $
 * $Author: dbrown $
 * $Id: file_names.cpp 1735 2006-02-09 21:47:26Z dbrown $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

// Implementation of writing routines
#include "file_names.hpp"

string endl_file_name( int outgoing_particle, int C, int I, int S)
{
  string s_f;
  ostringstream os_f;
  os_f<<
    setw(2)<<"yo"<<
    setw(2)<<outgoing_particle<<
    setw(1)<<"c"<<
    setw(2)<<C<<
    setw(1)<<"i"<<
    setw(3)<<I<<
    setw(1)<<"s"<<
    setw(3)<<S;

  //Copy output string stream to normal string
  s_f=os_f.str(); 

  //replace blanks with zeros...
  for( int i=0; i<s_f.length(); i++ )
    if ( s_f.at(i)==' ' )
      s_f.replace(i,1,"0") ;

  return( s_f );
}


string endf_file_name( int F, int T )
{
  string s_f;
  ostringstream os_f;
  os_f<<
    setw(2)<<"mf"<<
    setw(2)<<F<<
    setw(2)<<"mt"<<
    setw(3)<<T;

  //Copy output string stream to normal string
  s_f=os_f.str(); 

  //replace blanks with zeros...
  for( int i=0; i<s_f.length(); i++ )
    if ( s_f.at(i)==' ' )
      s_f.replace(i,1,"0") ;

  return( s_f );
}


