/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1891 $
 * $Date: 2006-09-06 12:31:58 -0700 (Wed, 06 Sep 2006) $
 * $Author: dbrown $
 * $Id: load_data.hpp 1891 2006-09-06 19:31:58Z dbrown $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

// prototypes

#ifndef ENDFB6_load_data
#define ENDFB6_load_data

#include <fstream>  // standard I/O package
#include <iostream> // for file I/O functions
#include <string>   // for character fun
#include <stdio.h>
#include <cmath>

#include "ENDF_file.hpp"

using namespace std;

//! This is the primary loop over the many different types of ENDF data files.
void LoadData( int F, int T);

//! This code reads in the MF=1 data and converts it to ENDL format data.
void LoadMF1Data( int T, mf1_file& inFile );

//! This code reads in all MF=1 fission data and converts it to ENDL format data.
void LoadFissionData(  );

//! Helper code to tell if MF=1, MT=MT file exists
bool MF1MTExists( int MT );

//! This code reads in the MF=3 data and converts it to ENDL format data.
void LoadMF3Data( mf3_file& inFile );

//! This code reads in the MF=4 data and converts it to ENDL format data.
void LoadMF4Data( mf4_file& inFile ); 

//! This code reads in the MF=5 data and converts it to ENDL format data.
void LoadMF5Data( mf5_file& inFile ); 

//! This code reads in the MF=6 data and converts it to ENDL format data.
void LoadMF6Data( mf6_file & infile );

//! This code reads in all gamma data (mostly in MF=12) and converts it to ENDL format data.
void LoadGammaData( mf12_file& inFile ); 

//! This code reads in the MF=13 data and converts it to ENDL format data.  For C=55 only.
void LoadMF13Data( mf13_file& inFile ); 

#endif
