/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1735 $
 * $Date: 2006-02-09 13:47:26 -0800 (Thu, 09 Feb 2006) $
 * $Author: dbrown $
 * $Id: mf15classes.hpp 1735 2006-02-09 21:47:26Z dbrown $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

// header for the MF=15 translation code

#ifndef MF15CLASSES
#define MF15CLASSES

#include "mf5classes.hpp"
#include "ENDF_file.hpp"
#include "multiplicity.hpp"

using namespace std;

// ----------- class MF15_list -----------------
// derive this class from mf5_table in order to use the table_interp routine
//! Class to handle the MF=15 data
class MF15_list : public mf5_table
{
private:
  // the weights for this model, depending on the incident neutron energy
  one_d_table weights;

public:
  multiplicity multiple;

  //! Reads in all continuuous gamma distributions.
  void read_data( mf15_file& inFile );

  //! Reads in continuuous gamma distribution for a single incident neutron energy.
  //! Sets done = true if the incident energy exceeds the ENDL maximum
  void one_e_dist( mf15_file& inFile, bool *done );

};

#endif
