/*
 * ******** fete: From ENDF To ENDL *********
 * 
 * Copyright (c) 2006, The Regents of the University of California. 
 * All rights reserved.
 * 
 * Produced at the Lawrence Livermore National Laboratory. 
 * Written by David A. Brown, Gerry Hedstrom, Tony Hill
 * 
 * This file is part of fete v1.0  (UCRL-CODE-218718)
 * 
 * Please read the COPYING file for "Our Notice and GNU General 
 * Public License" in the root of this software distribution.  
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License (as published by 
 * the Free Software Foundation) version 2, dated June 1991. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms 
 * and conditions of the GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 * 
 * $Revision: 1735 $
 * $Date: 2006-02-09 13:47:26 -0800 (Thu, 09 Feb 2006) $
 * $Author: dbrown $
 * $Id: record_types.hpp 1735 2006-02-09 21:47:26Z dbrown $
 * 
 * ******** fete: From ENDF To ENDL *********
 */

// prototypes of the set record readers

#ifndef ENDFB6_record_types
#define ENDFB6_record_types

#include <string>
#include <cmath>
#include <fstream>
#include <iostream>

using namespace std;

//! Converts a string with a format of double, double, int, int, int, int into numbers
void read_ddiiii(string *pS, 
		 double *pR1, double *pR2, 
		 int *pI1, int *pI2, int *pI3, int *pI4);

//! Converts a string with a format of int, double, int, int, int, int into numbers
void read_idiiii(string *pS, 
		 int *pI1, 
		 double *pR2, 
		 int *pI2, int *pI3, int *pI4, int *pI5);

//! Converts a string with a format of int, int, int, double, int, int, double, double, double
void read_iiidiiddd(string *pS, 
		    int *pI1, int *pI2, int *pI3,
		    double *pR1, 
		    int *pI4, int *pI5, 
		    double *pR2, double *pR3, double *pR4 );

//! Cpnverts a string with format of int, int, int, double, double, double, double, double 
void read_iiiddddd(string *pS, 
		 int *pI1, int *pI2, int *pI3,
		 double *pR1, double *pR2, double *pR3, 
		 double *pR4, double *pR5 );

//! Converts a string with a format of double into a double
void read_d(string *pS, double *pR);

//! Converts a string with a format of double, double into numbers
void read_dd(string *pS, double *pR1, double *pR2 );

//! Converts a string with a format of 3 doubles into numbers
void read_ddd(string *pS, double *pR1, double *pR2, double *pR3 );

//! Converts a string with a format of 6 doubles into numbers
void read_dddddd(string *pS, double *pR1, double *pR2, double *pR3,
  double *pR4, double *pR5, double *pR6 );

//! Converts a string with a format of int, int into numbers
void read_ii(string *pS, int *pI1, int *pI2 );

//! Finds the date in line 5 of the ENDF file
void read_date( string *pS, int *pI1 ) ;
#endif

//! Gets the incident particle from line 8 of the ENDF file
int read_yi( string *pS );
